/**
 *******************************************************************************
 * @file    main.c
 *
 * @brief   Main program body.
 *
 * @author  DPM
 *
 * @version V1.0.0
 *
 * @date    2024-5-6
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "main.h"
#include "dpm32m0xx.h"
#include "dpm32m0xx_eval.h"
#include "systick.h"
#include <stdio.h>

/**
  * @addtogroup DPM32M08X_LibSamples
  * @{
  */

/**
  * @addtogroup EPWM
  * @{
  */

/**
  * @addtogroup EPWM_DeadZoneInsertion
  * @{
  */

/* Private typedef --------------------------------------------------------------*/
GPIO_InitTypeStruct EPWM_GPIO_InitStruct;

/* Private define ---------------------------------------------------------------*/

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/
uint32_t reloadValue = 48000000 / 128 / 100 - 1; // 100ms;

/* Private functions ------------------------------------------------------------*/

/**
  * @brief  The program entry function.
  * @retval int
  */
int main(void)
{
  /* Configure the system clock */
  SystemClockInit();
  
  /* Configure the system tick */
  SystickInit();

  /* LED Init */
  EVAL_LedInit(LED1);

  /* Print Uart Init */
  EVAL_ComInit();
  
  /********************* Operation  *********************/
  /* Enable clock */
  RCC_Unlock();
  RCC_AHBPeriphClockCmd(RCC_AHB_PERIPH_GPIO, ENABLE);
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_EPWM, ENABLE);
  RCC_Lock();
  /* Config EPWM */
  GPIO_InitTypeStruct EPWM_GPIO_InitStruct;
  /* Config EPWM GPIO */
  EPWM_GPIO_InitStruct.GPIO_Mode = GPIO_MODE_ALT_FUNC;
  EPWM_GPIO_InitStruct.GPIO_Speed = GPIO_SPEED_HIGH;
  EPWM_GPIO_InitStruct.GPIO_OType = GPIO_OTYPE_PP;
  EPWM_GPIO_InitStruct.GPIO_PuPd = GPIO_PUPD_NOPULL;
  EPWM_GPIO_InitStruct.GPIO_Pin = GPIO_PIN_8 | GPIO_PIN_7;
  GPIO_Init(GPIOA, &EPWM_GPIO_InitStruct);
  GPIO_AltFuncConfig(GPIOA, GPIO_PIN_8, GPIO_ALT_FUNC_2);
  GPIO_AltFuncConfig(GPIOA, GPIO_PIN_7, GPIO_ALT_FUNC_2);
  GPIO_ResetBit(GPIOA, GPIO_PIN_8);
  GPIO_ResetBit(GPIOA, GPIO_PIN_7);
  /* Config EPWM_TIM */
  EPWM_TimeBaseInitTypeStruct EPWM_TimeBaseInitStruct;
  EPWM_TimeBaseStructInit(&EPWM_TimeBaseInitStruct);
  EPWM_TimeBaseInitStruct.EPWM_ClockDiv = EPWM_CLK_DIV128;
  EPWM_TimeBaseInitStruct.EPWM_CounterCycle = EPWM_COUNTER_CYCLE_PERIOD;
  EPWM_TimeBaseInitStruct.EPWM_CounterMode = EPWM_COUNTER_MODE_INCREASE_DECREASE;
  EPWM_TimeBaseInitStruct.EPWM_ReloadValue = reloadValue;
  EPWM_TimeBaseInit(&EPWM_TimeBaseInitStruct);
  /* Enable EPWM */
  EPWM_Cmd(ENABLE);
  /* Config EPWM_CH */
  EPWM_CHInitTypeStruct EPWM_CHInitStruct;
  EPWM_CHStructInit(&EPWM_CHInitStruct);
  EPWM_CHInitStruct.EPWM_Compare1Value = reloadValue / 2;
  EPWM_CHInitStruct.EPWM_Compare2Value = reloadValue / 2;
  EPWM_CHInitStruct.EPWM_CHInitStatus = EPWM_CH_INIT_STATUS_0;
  EPWM_CHInitStruct.EPWM_Compare1Action = EPWM_CMP_ACT_OUTPUT_FLIP;
  EPWM_CHInitStruct.EPWM_Compare2Action = EPWM_CMP_ACT_OUTPUT_FLIP;
  EPWM_CHInitStruct.EPWM_NPolarity = EPWM_CH_OUT_POLARITY_NORMAL;
  EPWM_CHInitStruct.EPWM_PPolarity = EPWM_CH_OUT_POLARITY_NORMAL;
  EPWM_CHInitStruct.EPWM_Compare1Dir = EPWM_CMP_DIR_INCREASE;
  EPWM_CHInitStruct.EPWM_Compare2Dir = EPWM_CMP_DIR_DECREASE;
  EPWM_CHInitStruct.EPWM_Compare1State = ENABLE;
  EPWM_CHInitStruct.EPWM_Compare2State = ENABLE;
  EPWM_CHInit(EPWM_CH0, &EPWM_CHInitStruct);
  /* Inject death time */
  EPWM_DeathTimeLenConfig(511);
  /* Enable EPWM CH0 */
  EPWM_CHCmd(EPWM_CH0, ENABLE);

  uint32_t ledTime = 0;
  /* Infinite loop */
  while(1)
  {
    /* Runing led toggle */
    if(ledTime < GetTick())
    {
      ledTime = GetTick() + 1000;
      EVAL_LedToggle(LED1);
    }
  }
}

/* retarget the C library printf function to the usart */
int fputc(int ch, FILE *f)
{
  UART_SendData(EVAL_COM0, (uint8_t)ch);

  while(RESET == UART_GetIntFlagStatus(EVAL_COM0, UART_INT_FLAG_TXE));

  return ch;
}


/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
